#include <string.h>
#include <stdio.h>

#define KEYLEN 200
char *getkey(char *key)
{

    static char buffer[KEYLEN];
    char *m, *ptr, *lastdot;

    m = strchr(key, '!');
    key = m + 1;


    ptr = buffer;
    while ((*ptr++ = *key++) != '@');

    lastdot = strrchr(key, '.');
    if (lastdot[1] < 'a')	/* is the host part an ip address? */
    {
	while (key < lastdot)
	{
	    *ptr++ = *key++;
	}
    } else
    {

	key = strchr(key, '.') + 1;

	while ((*ptr++ = *key++) != '\0');

	*ptr = '\0';
    }

    return buffer;
}

int main(int argc, char *argv[])
{
    char *at;
    char n[123], u[123], h[123];

    printf("%s\n", getkey(argv[1]));
    sscanf(argv[1], "%s!%s@%h", n, u, h);
    printf("nick: %s\n", n);
    printf("user: %s\n", u);
    printf("host: %s\n", h);
}
